local clopwh = require 'clopwh'

-- 2개의 class 를 만들고, 각 class 들이 구분가능한지 확인.

point = clopwh.Class({
	initialize = function(self, x, y)
		self.x = x or 0
		self.y = y or 0
	end,
	get_distance_from_center = function(self)
		return (self.x ^ 2 + self.y ^ 2) ^ 0.5
	end,
	set_x = function(self, x)
		self.x = x or 0
	end,
	set_y = function(self, y)
		self.y = y or 0
	end,
})

Int = clopwh.Class({
	initialize = function(self, value)
		self.value = value or 0
	end,
})

a = point(1, 1)
print(a.get_distance_from_center())
a.set_x(10)
a.set_y(10)
print(a.get_distance_from_center())
print(a.x)

print(clopwh.is_a(a, point))
print(clopwh.is_a(a, Int))

i = Int(1)

print(clopwh.is_a(i, point))
print(clopwh.is_a(i, Int))


-- 여기까지 테스트 통과.

Point = clopwh.Class({
	inherits = {point},
	get_distance_from_another = function(self, other)
		return ((self.x - other.x) ^ 2 + (self.y - other.y) ^ 2) ^ 0.5
	end,
})

a.set_x(0)
a.set_y(0)
b = Point(1, 1)
c = Point(0, 0)

print(clopwh.is_a(b, point)) -- true
print(clopwh.is_a(a, Point)) -- false
print(b.get_distance_from_center())
print(b.get_distance_from_another(a))

-- 여기까지는 의도한 대로 되는 듯.

print(clopwh.get_type(b) == clopwh.get_type(c))
print(clopwh.get_type(a) ~= clopwh.get_type(c))

-- Object 를 테스트한다

o = clopwh.Object()
print(clopwh.is_a(o, clopwh.Object))
print(clopwh.is_a(a, clopwh.Object))
print(clopwh.is_a(b, clopwh.get_type(o)))

-- 기본 자료형

print(clopwh.is_a(30, clopwh.Number))
print(clopwh.is_a("hello", clopwh.String))
print(clopwh.is_a(type, clopwh.Number))
print(clopwh.is_a({}, clopwh.Table))
